from typing import List
from cadwork import facet_list
from cadwork import point_3d


def get_last_error(error_code: int) -> str:
    """get last error
    Args:
        error_code ( int): error_code

    Returns:
        strerror string
    """


def rotate_height_axis_90(element_id_list: List[int]) -> None:
    """rotate height axis 90
    Args:
        element_id_list ( List[int]): element_id_list

    Returns:
        None
    """


def rotate_height_axis_180(element_id_list: List[int]) -> None:
    """rotate height axis 180
    Args:
        element_id_list ( List[int]): element_id_list

    Returns:
        None
    """


def set_over_width(element_id_list: List[int], value: float) -> None:
    """set over width
    Args:
        element_id_list ( List[int]): element_id_list
        value ( float): value

    Returns:
        None
    """


def set_over_height(element_id_list: List[int], value: float) -> None:
    """set over height
    Args:
        element_id_list ( List[int]): element_id_list
        value ( float): value

    Returns:
        None
    """


def set_over_length(element_id_list: List[int], value: float) -> None:
    """set over length
    Args:
        element_id_list ( List[int]): element_id_list
        value ( float): value

    Returns:
        None
    """


def set_rounding_width(element_id_list: List[int], value: float) -> None:
    """set rounding width
    Args:
        element_id_list ( List[int]): element_id_list
        value ( float): value

    Returns:
        None
    """


def set_rounding_height(element_id_list: List[int], value: float) -> None:
    """set rounding height
    Args:
        element_id_list ( List[int]): element_id_list
        value ( float): value

    Returns:
        None
    """


def set_rounding_length(element_id_list: List[int], value: float) -> None:
    """set rounding length
    Args:
        element_id_list ( List[int]): element_id_list
        value ( float): value

    Returns:
        None
    """


def set_cross_correction_negative_width(element_id_list: List[int], value: float) -> None:
    """set cross correction negative width
    Args:
        element_id_list ( List[int]): element_id_list
        value ( float): value

    Returns:
        None
    """


def set_cross_correction_positive_width(element_id_list: List[int], value: float) -> None:
    """set cross correction positive width
    Args:
        element_id_list ( List[int]): element_id_list
        value ( float): value

    Returns:
        None
    """


def set_cross_correction_negative_height(element_id_list: List[int], value: float) -> None:
    """set cross correction negative height
    Args:
        element_id_list ( List[int]): element_id_list
        value ( float): value

    Returns:
        None
    """


def set_cross_correction_positive_height(element_id_list: List[int], value: float) -> None:
    """set cross correction positive height
    Args:
        element_id_list ( List[int]): element_id_list
        value ( float): value

    Returns:
        None
    """


def set_cross_correction_negative_length(element_id_list: List[int], value: float) -> None:
    """set cross correction negative length
    Args:
        element_id_list ( List[int]): element_id_list
        value ( float): value

    Returns:
        None
    """


def set_cross_correction_positive_length(element_id_list: List[int], value: float) -> None:
    """set cross correction positive length
    Args:
        element_id_list ( List[int]): element_id_list
        value ( float): value

    Returns:
        None
    """


def apply_global_scale(element_id_list: List[int], scale: float, origin: point_3d) -> None:
    """apply global scale
    Args:
        element_id_list ( List[int]): element_id_list
        scale ( float): scale
        origin ( point_3d): origin

    Returns:
        None
    """


def auto_regenerate_axes(element_id_list: List[int]) -> None:
    """auto regenerate axes
    Args:
        element_id_list ( List[int]): element_id_list

    Returns:
        None
    """


def rotate_length_axis_90(element_id_list: List[int]) -> None:
    """rotate length axis 90
    Args:
        element_id_list ( List[int]): element_id_list

    Returns:
        None
    """


def rotate_length_axis_180(element_id_list: List[int]) -> None:
    """rotate length axis 180
    Args:
        element_id_list ( List[int]): element_id_list

    Returns:
        None
    """


def invert_model(element_id_list: List[int]) -> None:
    """invert model
    Args:
        element_id_list ( List[int]): element_id_list

    Returns:
        None
    """


def set_width_real(elements: List[int], width: float) -> None:
    """set width real
    Args:
        elements ( List[int]): elements
        width ( float): width

    Returns:
        None
    """


def set_height_real(elements: List[int], height: float) -> None:
    """set height real
    Args:
        elements ( List[int]): elements
        height ( float): height

    Returns:
        None
    """


def set_length_real(elements: List[int], length: float) -> None:
    """set length real
    Args:
        elements ( List[int]): elements
        length ( float): length

    Returns:
        None
    """


def rotate_height_axis_2_points(elements: List[int], point1: point_3d, point2: point_3d) -> None:
    """rotate height axis 2 points
    Args:
        elements ( List[int]): elements
        point1 ( point_3d): point1
        point2 ( point_3d): point2

    Returns:
        None
    """


def clear_errors() -> None:
    """clear errors
    Args:

    Returns:
        None
    """


def set_drilling_tolerance(elements: List[int], tolerance: float) -> None:
    """set drilling tolerance
    Args:
        elements ( List[int]): elements
        tolerance ( float): tolerance

    Returns:
        None
    """


def auto_regenerate_axes_silently(a0: List[int]) -> None:
    """auto regenerate axes silently
    Args:
        a0 ( List[int]): a0

    Returns:
        None
    """


def rotate_length_axis_2_points(elements: List[int], point1: point_3d, point2: point_3d) -> None:
    """rotate length axis 2 points
    Args:
        elements ( List[int]): elements
        point1 ( point_3d): point1
        point2 ( point_3d): point2

    Returns:
        None
    """


def get_width(element_id: int) -> float:
    """get width
    Args:
        element_id ( int): element_id

    Returns:
        floatelement width
    """


def get_height(element_id: int) -> float:
    """get height
    Args:
        element_id ( int): element_id

    Returns:
        floatelement height
    """


def get_length(element_id: int) -> float:
    """get length
    Args:
        element_id ( int): element_id

    Returns:
        floatelement length
    """


def get_p1(element_id: int) -> point_3d:
    """get p1
    Args:
        element_id ( int): element_id

    Returns:
        point_3delement P1
    """


def get_p2(element_id: int) -> point_3d:
    """get p2
    Args:
        element_id ( int): element_id

    Returns:
        point_3delement P2
    """


def get_p3(element_id: int) -> point_3d:
    """get p3
    Args:
        element_id ( int): element_id

    Returns:
        point_3delement P3
    """


def get_start_height_cut_angle(element_id: int) -> float:
    """get start height cut angle
    Args:
        element_id ( int): element_id

    Returns:
        floatelement start height cut angle
    """


def get_start_width_cut_angle(element_id: int) -> float:
    """get start width cut angle
    Args:
        element_id ( int): element_id

    Returns:
        floatelement start width cut angle
    """


def get_end_height_cut_angle(element_id: int) -> float:
    """get end height cut angle
    Args:
        element_id ( int): element_id

    Returns:
        floatelement end height cut angle
    """


def get_end_width_cut_angle(element_id: int) -> float:
    """get end width cut angle
    Args:
        element_id ( int): element_id

    Returns:
        floatelement end width cut angle
    """


def get_over_width(element_id: int) -> float:
    """get over width
    Args:
        element_id ( int): element_id

    Returns:
        floatelement overwidth
    """


def get_over_height(element_id: int) -> float:
    """get over height
    Args:
        element_id ( int): element_id

    Returns:
        floatelement overheight
    """


def get_over_length(element_id: int) -> float:
    """get over length
    Args:
        element_id ( int): element_id

    Returns:
        floatelement overlength
    """


def get_rounding_width(element_id: int) -> float:
    """get rounding width
    Args:
        element_id ( int): element_id

    Returns:
        floatelement rounding width
    """


def get_rounding_height(element_id: int) -> float:
    """get rounding height
    Args:
        element_id ( int): element_id

    Returns:
        floatelement rounding height
    """


def get_rounding_length(element_id: int) -> float:
    """get rounding length
    Args:
        element_id ( int): element_id

    Returns:
        floatelement rounding length
    """


def get_cross_correction_negative_width(element_id: int) -> float:
    """get cross correction negative width
    Args:
        element_id ( int): element_id

    Returns:
        floatelement negative width cross correction
    """


def get_cross_correction_positive_width(element_id: int) -> float:
    """get cross correction positive width
    Args:
        element_id ( int): element_id

    Returns:
        floatelement positive width cross correction
    """


def get_cross_correction_negative_height(element_id: int) -> float:
    """get cross correction negative height
    Args:
        element_id ( int): element_id

    Returns:
        floatelement negative height cross correction
    """


def get_cross_correction_positive_height(element_id: int) -> float:
    """get cross correction positive height
    Args:
        element_id ( int): element_id

    Returns:
        floatelement positive height cross correction
    """


def get_cross_correction_negative_length(element_id: int) -> float:
    """get cross correction negative length
    Args:
        element_id ( int): element_id

    Returns:
        floatelement negative length cross correction
    """


def get_cross_correction_positive_length(element_id: int) -> float:
    """get cross correction positive length
    Args:
        element_id ( int): element_id

    Returns:
        floatelement positive length cross correction
    """


def get_weight(element_id: int) -> float:
    """get weight
    Args:
        element_id ( int): element_id

    Returns:
        floatelement real weight
    """


def get_list_weight(element_id: int) -> float:
    """get list weight
    Args:
        element_id ( int): element_id

    Returns:
        floatelement list weight
    """


def get_volume(element_id: int) -> float:
    """get volume
    Args:
        element_id ( int): element_id

    Returns:
        floatelement real volume
    """


def get_list_volume(element_id: int) -> float:
    """get list volume
    Args:
        element_id ( int): element_id

    Returns:
        floatelement list volume
    """


def get_xl(element_id: int) -> point_3d:
    """get xl
    Args:
        element_id ( int): element_id

    Returns:
        point_3delement XL vector
    """


def get_yl(element_id: int) -> point_3d:
    """get yl
    Args:
        element_id ( int): element_id

    Returns:
        point_3delement YL vector
    """


def get_zl(element_id: int) -> point_3d:
    """get zl
    Args:
        element_id ( int): element_id

    Returns:
        point_3delement ZL vector
    """


def get_center_of_gravity(element_id: int) -> point_3d:
    """get center of gravity
    Args:
        element_id ( int): element_id

    Returns:
        point_3delement center of gravity
    """


def get_reference_side(element_id: int) -> int:
    """get reference side
    Args:
        element_id ( int): element_id

    Returns:
        intelement reference side
    """


def get_element_vertices(element_id: int) -> List[point_3d]:
    """get element vertices
    Args:
        element_id ( int): element_id

    Returns:
        List[point_3d]element vertices
    """


def get_element_facets(element_id: int) -> facet_list:
    """get element facets
    Args:
        element_id ( int): element_id

    Returns:
        facet_listelement facets
    """


def get_list_width(element_id: int) -> float:
    """get list width
    Args:
        element_id ( int): element_id

    Returns:
        floatelement list width
    """


def get_list_height(element_id: int) -> float:
    """get list height
    Args:
        element_id ( int): element_id

    Returns:
        floatelement list height
    """


def get_list_length(element_id: int) -> float:
    """get list length
    Args:
        element_id ( int): element_id

    Returns:
        floatelement list length
    """


def get_minimum_distance_between_elements(first_id: int, second_id: int) -> float:
    """get minimum distance between elements
    Args:
        first_id ( int): first_id
        second_id ( int): second_id

    Returns:
        floatminimum distance
    """


def get_total_area_of_all_faces(element: int) -> float:
    """get total area of all faces
    Args:
        element ( int): element

    Returns:
        floatelement total faces area
    """


def get_area_of_front_face(element: int) -> float:
    """get area of front face
    Args:
        element ( int): element

    Returns:
        floatelement front face area
    """


def get_door_surface(elements: List[int]) -> float:
    """get door surface
    Args:
        elements ( List[int]): elements

    Returns:
        floatelement door surface
    """


def get_window_surface(elements: List[int]) -> float:
    """get window surface
    Args:
        elements ( List[int]): elements

    Returns:
        floatelement window surface
    """


def get_local_x() -> point_3d:
    """get local x
    Args:

    Returns:
        point_3dlocal X vector
    """


def get_local_z() -> point_3d:
    """get local z
    Args:

    Returns:
        point_3dlocal Y vector
    """


def get_local_y() -> point_3d:
    """get local y
    Args:

    Returns:
        point_3dlocal Z vector
    """


def get_drilling_tolerance(element: int) -> float:
    """get drilling tolerance
    Args:
        element ( int): element

    Returns:
        floatthe drilling tolerance
    """


def get_element_reference_face_vertices(element_id: int) -> List[point_3d]:
    """get element reference face vertices
    Args:
        element_id ( int): element_id

    Returns:
        List[point_3d]vertexlist of all points
    """


def get_element_reference_face_area(element_id: int) -> float:
    """get element reference face area
    Args:
        element_id ( int): element_id

    Returns:
        floatarea(size) of reference face
    """


def get_center_of_gravity_for_list(elements: List[int]) -> point_3d:
    """get center of gravity for list
    Args:
        elements ( List[int]): elements

    Returns:
        point_3d
    """


def get_center_of_gravity_for_list_considering_materials(elements: List[int]) -> point_3d:
    """get center of gravity for list considering materials
    Args:
        elements ( List[int]): elements

    Returns:
        point_3d
    """


def get_element_facet_count(element_id: int) -> int:
    """get element facet count
    Args:
        element_id ( int): element_id

    Returns:
        int
    """


def get_weight_real(element_id: int) -> float:
    """get weight real
    Args:
        element_id ( int): element_id

    Returns:
        float
    """


def get_actual_physical_weight(a0: int) -> float:
    """get actual physical weight
    Args:
        a0 ( int): a0

    Returns:
        float
    """


def get_actual_physical_volume(a0: int) -> float:
    """get actual physical volume
    Args:
        a0 ( int): a0

    Returns:
        float
    """


def are_facets_coplanar(a0: List[point_3d], a1: List[point_3d]) -> bool:
    """are facets coplanar
    Args:
        a0 ( List[point_3d]): a0
        a1 ( List[point_3d]): a1

    Returns:
        bool
    """
